import { Options, ContainerInteractivity, Svg, Image, Bubble, Repulse } from '../utils/interfaces';
import { Retina } from './retina';
import { Canvas } from './canvas';
import { Particles } from './particles';
import { ProcessBubbleType } from '../utils/enums';
import { Particle } from './particle';
export declare class Container {
    interactivity: ContainerInteractivity;
    options: Options;
    retina: Retina;
    canvas: Canvas;
    particles: Particles;
    checkAnimFrame?: number;
    drawAnimFrame?: number;
    bubble: Bubble;
    repulse: Repulse;
    svg: Svg;
    img: Image;
    lastFrameTime: number;
    pageHidden: boolean;
    constructor(tag_id: string, params: Options);
    handleVisibilityChange(): void;
    eventsListeners(): void;
    densityAutoParticles(): void;
    destroypJS(): void;
    exportImg(): void;
    loadImg(type: string): Promise<void>;
    requestFrame(callback: FrameRequestCallback): number;
    cancelAnimation(handle: number): void;
    draw(timestamp: DOMHighResTimeStamp): void;
    checkBeforeDraw(): void;
    processBubble(p: Particle, dist_mouse: number, time_spent: number, bubble_param: number, particles_param: number, p_obj_bubble: number | undefined, p_obj: number, id: ProcessBubbleType): void;
    init(): void;
    start(): Promise<void>;
}
