import { ParticleImage, Color, Coordinates } from '../utils/interfaces';
import { Container } from './container';
import { ShapeType } from '../utils/enums';
export declare class Particle {
    pJSContainer: Container;
    radius: number;
    size_status?: boolean;
    vs?: number;
    x: number;
    y: number;
    offsetX: number;
    offsetY: number;
    color: Color;
    opacity: number;
    opacity_status?: boolean;
    vo?: number;
    vx: number;
    vy: number;
    vx_i: number;
    vy_i: number;
    shape?: ShapeType;
    img?: ParticleImage;
    radius_bubble?: number;
    opacity_bubble?: number;
    text?: string;
    constructor(pJSContainer: Container, color: {
        value: string[] | Color | string;
    }, opacity: number, position?: Coordinates);
    draw(): void;
    subDraw(ctx: CanvasRenderingContext2D, img_obj: HTMLImageElement, radius: number): void;
    drawShape(ctx: CanvasRenderingContext2D, startX: number, startY: number, sideLength: number, sideCountNumerator: number, sideCountDenominator: number): void;
    checkOverlap(position?: Coordinates): void;
    initBubble(): void;
    grab(): void;
    bubble(): void;
    repulse(): void;
    processRepulse(dx: number, dy: number, force: number): void;
    link(p2: Particle): void;
    attract(p2: Particle): void;
    bounce(p2: Particle): void;
}
